'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'III  BASIC++     DEMO ZUR C-CONTROL MICRO                 IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' Beispiel zum BASIC-COMPUTER   und Zubehr
'                  
' ANWENDUNG:   IIC-BUS PORTERWEITERUNG (19 88 48) MIT PCF8574 
'              PCF 8574    PORTS LESEN/SCHREIBEN
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterungals. Der Treiber enhalt alle Teile zum Lesen und Schreiben
' eines PCF 8574. Er kann allgemein zum Betrieb dieses Bausteins am IIC BUS
' verwendet werden und ist nicht unbedingt an das Zubehr gebunden.
'----------------------------------------------------------------------
' Der PCF8574 wird ber einen IIC-Bus angesteuert
' der hier als BASIC-Treiber ausgefhrt ist. Der IIC-Bus bentigt zwei
' Ports, Stellt aber selbst 8 Ports zur Verfgung.
' Die Ports fr den IIC-Bus sind hier PORT2=SDA und PORT5=SCL
' Sie knnen natrlich mehrere PCF5478 an der MICRO betreiben.
' Dazu mssen die Bausteine natrlich unterschiedliche Adressen haben.
' Am Treiber ndert sich in diesem Fall nichts, aber Sie mssen ADDRESS
' vor Aufruf von WRITEBYTE oder READBYTE eine aktuelle Schreib-Adresse
' geben


' SCHNITTSTELLE ZUM TREIBER
' Die FUNCTION WRITEBYTE erwartet die bergabe der W-Adresse des PCF
' 8574 und ein Datenbyte.
' Die FUNCTION READBYTE schreibt das vom PCF8574 gelesene Byte in die
' globale Variable DATABYTE. bergeben wird die W-Adresse, die READ-Adresse
' erzeugt der Treiber selbst. 
' Der Treiber selbst bentigt etwa 200 BASIC Bytes Programmspeicher.
'
' DEMO WRITE_DATA
' Die Demo erzeugt ein Lauflicht an den Ports 1 bis 8.
' kommentieren sie die Zeile "GOTO READ_DEMO" aus um dieses Beispiel
' zu starten
'
' DEMO READ_DATA
' Das Beispiel liest den PCF8574 Port und schaltet Port 6
' (LED6 auf dem P/E-Board) entsprechend dem Portzustand P1

' Sie knnen SDA und SCL natrlich auch auf andere Digitalports legen,
' wenn Ihre Anwendung das erfordert.
'
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'---- PROGRAMM ------------
define LAMP     port[6]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- IIC INTERFACE  -------
define DATABYTE as byte

'------- PROGRAM ----------
'define COUNTER      byte[5]

'--PCF8574 DEVICE W/R ADDRESS -------
const ADDRESS = 01001110b

import "....\LIB\MICRO_IIC_GENERIC.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"

'---------- IICBUS INIT ------------------
SDA=on
SCL=on
LAMP=on
pause 10

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
goto READ_DEMO

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II    DEMO WRITE DATA TO PCF 8574      II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#WRITE_DEMO
define MOVE as byte
define COUNTER as byte
MOVE=1
#WLOOP
for counter=1 to 7
MOVE= MOVE shl 1
WRITEBYTE(ADDRESS,MOVE)
pause 10
next COUNTER
'-----------------------------------------
for counter=1 to 7
MOVE= MOVE shr 1
WRITEBYTE(ADDRESS,MOVE)
pause 10
next COUNTER
goto WLOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II    DEMO READ DATA FROM PCF 8574     II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#READ_DEMO
WRITEBYTE(ADDRESS,FFh)
#RLOOP
READBYTE(ADDRESS)
lamp= (DATABYTE and 1)
goto RLOOP

attributes
ccproject              
ccproject              
            
    
   
      
    
end attributes
