'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIII  BASIC++   DEMO ZUR C-CONTROL UNIT MICRO               IIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER mit dem Programmer/Application-Board
'--------------------------------------------------------------------
' Beschreibung
' Ein kleines TOOL um die OS Version der MICRO zu lesen. Die Version
' steht nach dem Einschalten in der Variablen Byte[24]
' Der Inhalt 01 steht z.B. fr OS V 2.01
' Die Ausgabe erfolgt auf ein LCD, angeschlossen an einen PCF 8574
' auf Adresse &B01001110
' Dieses LCD ist unter der Best.Nr 198330 erhltlich
'
' Zustzlich blinkt LED4 auf dem P/E Board um die Version auch zu identifizieren, 
' wenn sie kein LCD angeschlossen haben 
' Einer Version 2.03 blinkt z.B. 3 mal und wiederholt das Blinken nach
' kurzer Pause.
'
'-------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define LED      port[4]
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
define DATABYTE as byte
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- PROGRAMM       -------
define COUNTER     as byte
define HUNDERTER   as byte
define ZEHNER      as byte
define EINER       as byte
define VERSION      byte[24]

const ADDR=01001110b' LCD ADRESSE


import "...\LIB\ASCII_TABLE.BAS"
import "...\LIB\MICRO_IIC_GENERIC.BAS"
import "...\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "...\LIB\MICRO_IIC_LCD_DRIVE.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS()
HUNDERTER=VERSION/100
ZEHNER=(VERSION-(HUNDERTER*100))/10
EINER=VERSION-HUNDERTER*100-ZEHNER*10 
END FUNCTION

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   PCF 8574 PORTERWEITERUNG FR LCD        II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'----------------------------------------------
pause 2
LCD_INIT(ADDR)
SPLIT_DIGITS()

'----- WRITE CHARACTERS LINE 1 ---------------
LINE1(ADDR,4)
LCD_WRITE(ADDR,20h,V)
LCD_WRITE(ADDR,20h,E)
LCD_WRITE(ADDR,20h,R)
LCD_WRITE(ADDR,20h,S)
LCD_WRITE(ADDR,20h,BLANK)
LCD_WRITE(ADDR,20h,32h)
LCD_WRITE(ADDR,20h,DOT)
LCD_WRITE(ADDR,20h,ZEHNER+30h)
LCD_WRITE(ADDR,20h,EINER+30h)

#LOOP
if VERSION =0 then goto LOOP
for COUNTER= 1 to VERSION
LED=on
pause 5
LED=off
pause 20
next
pause 50
goto LOOP

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII








attributes
ccproject                
ccproject               
           
         
         
        
      
     
    
   
   
    
end attributes
