'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIII  BASIC++   DEMO ZUR C-CONTROL UNIT MICRO               IIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'' Beispiel zum BASIC-COMPUTER   und Zubehr
'
' ANWENDUNG:   MICROMODUL  (19 83 81) ANSTEURUNG LCD AM APPLICATION BOARD
'              BENCHMARK
'--------------------------------------------------------------------
'-----------------------------------------------------------------------
' Beschreibung
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterung. Der PCF8574 befindet sich auf dem IIC-BUS LCD MODUL
' bzw. auf dem MICROMODUL und steuert in diesem Fall das LCD des
' Application Board an.
' Der IIC-BUS liegt am MICROMODUL an den Ports 5 und 6. 
' Deshalb wird hier, abweichend von anderen Beispielen zun IIC-BUS
' der BASIC-Treiber "MICRO_IIC_GENERICX.BAS" geladen.
' Dieses Beispiel spricht den PCF8574 auf dem MICROMODUL auf der
' Adresse 01001110 an, alle Adress-Jumper auf dem MICROMODUL mssen daher
' abgezogen sein
'
' Das Programm ist ein Benchmark zur Messung der Geschwindigkeit der MICRO.

'------------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN

'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[5]
define SCL      port[6]
define DATABYTE as byte
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
define INSTRUC100  as byte
define HUNDERTER   as byte
define ZEHNER      as byte
define EINER       as byte
const ADDR=01001110b' LCD ADRESSE


import "....\LIB\ASCII_TABLE.BAS"
import "....\LIB\MICRO_IIC_GENERICX.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"
import "....\LIB\MICRO_BMX.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS()
HUNDERTER=INSTRUC100/100
ZEHNER=(INSTRUC100-(HUNDERTER*100))/10
EINER=INSTRUC100-HUNDERTER*100-ZEHNER*10 
END FUNCTION
'----------------------------------------------------

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   MICRO BENCHMARK (IIC-LCD REQUIRED)      II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'----------------------------------------------
pause 2
LCD_INIT(ADDR)
pause 2
'----- WRITE CHARACTERS LINE 1 ---------------
#LOOP
BMX()
SPLIT_DIGITS()
LINE1(ADDR,3)
LCD_WRITE(ADDR,20h,B)
LCD_WRITE(ADDR,20h,M)
LCD_WRITE(ADDR,20h,X)
LCD_WRITE(ADDR,20h,BLANK)
LCD_WRITE(ADDR,20h,HUNDERTER+30h)
LCD_WRITE(ADDR,20h,ZEHNER+30h)
LCD_WRITE(ADDR,20h,EINER+30h)
LCD_WRITE(ADDR,20h,30h)
LCD_WRITE(ADDR,20h,30h)
LCD_WRITE(ADDR,20h,BLANK)
LCD_WRITE(ADDR,20h,I)
LCD_WRITE(ADDR,20h,2Fh)
LCD_WRITE(ADDR,20h,S)

goto LOOP
table tabx
0
END TABLE
attributes
ccproject                     
ccproject                    
                
              
              
             
           
          
         
        
       
      
     
    
   
  
 
end attributes
