'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII     BASIC++  DEMO ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'
' ANWENDUNG:   MICROMODUL  (19 83 81) ANSTEURUNG LCD AM APPLICATION BOARD
'              TASTATURABFRAGE APPLICATION-BOARD
'-----------------------------------------------------------------------
' Sie sehen hier die Anwendung der C-Control MICRO mit einer PCF8574
' Porterweiterung. Der PCF8574 befindet sich auf dem IIC-BUS LCD MODUL
' bzw. auf dem MICROMODUL und steuert in diesem Fall das LCD des
' Application Board an.
' Der IIC-BUS liegt am MICROMODUL an den Ports 5 und 6. 
' Deshalb wird hier, abweichend von anderen Beispielen zun IIC-BUS
' der BASIC-Treiber "MICRO_IIC_GENERICX.BAS" geladen.
' Dieses Beispiel spricht den PCF8574 auf dem MICROMODUL auf der
' Adresse 01001110 an, alle Adress-Jumper auf dem MICROMODUL mssen daher
' abgezogen sein
' In diesem Beispiel wird der PORT 2 der MICRO als AD[2] verwendet um die
' Tastatur am Application-Board zu lesen
' Dazu muss der PORT2 der MICRO mit AD8 auf der BUSLEISTE des Application
' Boards am Patchfeld verbunden sein. Sie knnen die Portbelegung fr den Anschluss der
' Tastatur im Programm "MICRO_GET_KEY.BAS" in der LIB ndern.
'
' Das Programm zeigt am LCD den Tastencode 0 bis 9 fr die jeweiligen Ziffern
' und die Codes 11 bis 16 fr Funktionstasten A bis F.
'----------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[5]
define SCL      port[6]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- IIC INTERFACE  -------
define DATABYTE as byte

'---------------------------
define KEYCODE     as byte  
define TAUSENDER   as byte
define HUNDERTER   as byte
define ZEHNER      as byte
define EINER       as byte
define KEY         as byte
'-------------------------



'------ PCF8574 LCD DEVICE WRITE ADDRESS -------
const LADDR = 01001110b

import "....\LIB\ASCII_TABLE.BAS"
import "....\LIB\MICRO_IIC_GENERICX.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"
import "....\LIB\MICRO_GET_KEY.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS(VALUE as byte)
HUNDERTER=VALUE/100
ZEHNER=(VALUE-(HUNDERTER*100))/10
EINER=VALUE-HUNDERTER*100-ZEHNER*10 
END FUNCTION
'----------------------------------------------------


'---------- IICBUS INIT ------------------
SDA=on
SCL=on
pause 1

'----------- LCD INIT --------------------
lcd_init(LADDR)
pause 2
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   MATRIX KEY-DECODE AND DISPLAY     II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
#LOOP
'----- WRITE CHARACTERS LINE 1 ---------------
LINE1(LADDR,4)
LCD_WRITE(LADDR,20h,K)
LCD_WRITE(LADDR,20h,E)
LCD_WRITE(LADDR,20h,Y)
LCD_WRITE(LADDR,20h,BLANK)
GET_KEY()

SPLIT_DIGITS(KEYCODE)
LCD_WRITE(LADDR,20h,HUNDERTER+30h)
LCD_WRITE(LADDR,20h,ZEHNER+30h)
LCD_WRITE(LADDR,20h,EINER+30h)
goto LOOP

attributes
ccproject                        
ccproject                      
                    
            
          
                
             
           
           
ccproject               
       
     
end attributes
