'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIII      BASIC++    DEMO ZUR C-CONTROL MICRO             IIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

'-----------------------------------------------------------------------
' THEMA: FUNCTION()                UNTERPROGRAMME
'-----------------------------------------------------------------------
' Funktionen und Unterprogramme knnen Ihren Quellcode aufteilen und somit
' strukturierter und lesbarer machen. Auerdem knnen Sie in Unterprogrammen
' Anweisungen integrieren, die Sie hufiger verwenden. Generell sollten Sie so
' hufig es geht Programmcode in Funktionen auslagern. Dies erhht nicht nur die
' Lesbarkeit, sondern oft auch die Performance und den bentigten Speicherplatz
' Ihres Programms.
' Im Gegensatz zu seinem Vorgnger ist  Basic++ viel modularer aufgebaut.
' Einen entscheidenden Vorteil bringt die Parameterbergabe von Funktionen mit
' sich.
' Daneben wurden durch das neue modularere Konzept von CCBasic++ auch
' verschiedene Geltungsbereiche (global und lokal) fr Variablen eingefhrt.
' FUNCTION  Ein Unterprogramm leiten Sie mit dem Befehl FUNCTION" ein. Jedes
' Unterprogramm bentigt einen eindeutigen Namen, wobei der Name den
' allgemeinen Namenskonventionen entspricht, die Sie auch schon fr Variablen-
' und Sprungmarkennamen kennen gelernt haben.
' Syntax:     FUNCTION Funktionsname([Parameter [AS] Datentyp[, ]) 
'                 ' Hier Pr grammc de 
'                
'             END FUNCTION 
' Wie Sie an der Syntaxdefinition schon erkennen knnen mssen auch Funktionen
' mit END FUNCTION geschlossen werden.
'-----------------------------------------------------------------------------
' ACHTUNG:
' Sie drfen bei der MICRO keine Parameter aus der FUNCTION zurckgeben.
' Sie drfen also den Befehl RETURN nicht benutzen.
'------------------------------------------------------------------------------

'
' Zwischen der geffneten und geschlossenen Klammer hinter dem Funktionsname
' knnen Sie optional Parameter listen, die beim Aufruf der Funktion gesetzt
' werden mssen. Parameter sind lokale Variablen, die nur innerhalb der Funktion
' verwendet werden knnen. Der Umgang und die Gebrauchskonventionen von
' Parameter entspricht dem von normalen Variablen, die mit DEFINE erstellt
' wurden.
'
' Beispiel FUNCTION  ohne Parameterbergabe:  
' Es ist das vorherige Beispiel, nur dass die Erzeugeng des BEEP in einer
' FUNCTION erfolgt 
' Hier wird der ADC6 bemeinsam mit einem BEEPER an diesem Port betrieben.
' Das Programm aktiviert nach berschreiten einer bestimmten Spannung an ADC6
' (hier etwa 2V)die LED und den BEEPER. Drehen Sie am Poti um die Funktion zu
' prfen. Drehen gegen den Uhreigersinn vergrssert die Spannung.
'--------------------------------------------------------------------------
' Stecken Sie bitte die Jumper JP2 und JP1 (auf Position 1-2)damit die Demo korrekt
' funktioniert.
'--------------------------------------------------------------------------

'

'--------------------------
'------ I/O PORTS ---------
'--------------------------
define COUNTER  byte[1]
define STOP     byte[2]
define LED      port[5]
define BEEPER   port[6]
define ADC1     ad[1]
define ADC2     ad[2]
define ADC5     ad[5]
define ADC6     ad[6]
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------


'---------------------------------------------------
FUNCTION BEEPING()
BEEP 100,5,BEEPER
deact BEEPER
pause 10
END FUNCTION
'---------------------------------------------------


'--------------------------------------------------
'  SHARING A PORT FOR BEEPING AND AD-CONVERTER    -
'--------------------------------------------------
#START
if ADC6>100 then BEEPING
if ADC6>100 then LED=on
if ADC6<100 then LED=off
goto START







attributes
   
 
end attributes
