----------------------------------------------------------------------------
                       Willkommen bei Basic++ 
----------------------------------------------------------------------------

DER STANDARD-BASIC KERN

BASIC++ bietet den bisherigen Nutzern von CCBASIC eine Alternative, die sich in den
Kernfunktionen und der Syntax kaum von CCBASIC unterscheidet. Umsteiger, deren 
Erfahrungen sich auf das Standard-BASIC beschrnken knnen sofort ihre Programme
formulieren, da die zustzlichen Resourcen der UNIT M1.2 / M 2.0 mit wenigen
einfachen Syntax-Erweiterungen zugnglich sind.


DIE SYNTAX ERWEITERUNGEN VON BASIC++
Um den Kern des Standard-BASIC sind zahlreiche neue Funktionen verfgbar. 
Sie erschliessen die erweiterten Resourcen der UNIT M 2.0 in einer einfachen 
Syntax-Erweiterung und bieten darber hinaus Features wie sie von modernen 
Hochsprachen zur Verfgung gestellt werden.


DIE MODULARITT VON BASIC++
Im Gegensatz zu Standard-BASIC Dialekten ist Basic++ viel modularer aufgebaut.
Einen entscheidenden Vorteil bringt die Parameterbergabe von Funktionen mit
sich.
Daneben wurden mit dem  modularen Konzept von CCBasic++ auch die Import-
mglichkeit von Funktionen und verschiedene Geltungsbereiche (global und lokal) 
fr Variablen eingefhrt.
Damit hat der Anwender die Mglichkeit fertige Programm-Module aus 
(eigenen oder anderen, allgemein zugnglichen) Bibliotheken zu integrieren,
was den Programmieraufwand  deutlich reduziert und die Lesbarkeit der Programme
entscheidend verbessert.



Beispiele:
Die Beispiele sind einfach gehalten um den Kern der Thematik programmtechnisch 
darzustellen und benutzen (soweit es mglich ist) nur die Befehle und Techniken 
des Standard BASIC, wie sie es z.B. von CCBASIC kennen.
Bei komplexeren Beispielen finden sie zustzlich Varianten die alle Features von
BASIC++ nutzen und Ihnen zeigen wie diese Sprache effektiv eingesetzt wird.
Diese Varianten sind mit ++ gekennzeichnet.

 - Definition lokaler/globaler Variablen
 - Funktionsaufruf mit Parameterbergabe
 - Importierung von Funktionen
 
Auch wenn Sie zunchst Berhrungsngste mit diesen Neuerungen haben, sollten
Sie sich trotzdem diese Beispiele ansehen. Sie werden sehr schnell erkennen
wie einfach die Handhabung ist und wie bersichtlich sich Ihre Programme gestalten lassen.
Ausserden finden Sie in der LIBRARY eine Auswahl von Programmen die Sie in Ihren
Anwendungen untersttzen.

Anwender:
Basic++ ist sowohl fr den Einstieg (einfache Kernfunktionen) als auch 
fr die professionelle Programmierung der C-Control I optimiert.
Diese Dokumentation richtet sich sowohl an Anfnger als auch
Fortgeschrittene, wobei sie sowohl als Lernmittel, als auch als Referenz
genutzt werden kann. 

---------------------------------------------------------------------------------
               Allgemeine Hinweise zu den Beispielen:
---------------------------------------------------------------------------------
1)SPEICHER
Sie werden bei den Beispielen zur MICRO merken, dass oft weit mehr als 24 Variablen
gebraucht werden. Der Speicher ist bei der MICRO so organisiert,
dass der Variablenspeicher bis in das Stack des Controllers reichen kann.
Das bedeutet, dass bei der MICRO  tatschlich ca. 45 Variablen zur Verfgung stehen.
Garantiert kann das aber nicht werden, weil ich nur schtzen kann, wie weit der
Controller in das Stack schreibt
Bei der UNIT M 2.0/1.2 knnen bis zu 15 Variablen mehr genutzt werden, wenn der
RECEIVE-BUFFER der seriellen Schnittstellen nicht bentigt wird. 

2)LIBRARY
Entpacken Sie die Beispiele in das Verzeichnis BASICPP und die Dateien
der Library in das Verzeichnis LIB.
Damit die Beispiele funktionieren, muss die Verzeichnisstruktur eingehalten werden, 
da viele Beispiele Dateien Aus der LIB laden.

BASICPP
      I- COMPILER
      I- LIB
      I- REFERENZ
      I- UNIT_M2.0_M1.2
      I- UNIT_MICRO
      I- UNIT_STATION


Mit der Installation von BASIC++ wird bereits eine Library erzeugt, die z.T
sparsamer mit den verfgbaren Variablen umgeht, als die hier gebotene Library.


3)WORD[1]
Manche Beispiele verwenden die Konvetionen des ursprnglichen CCBAS und definieren
WORD[1] bzw. BYTE[1] und BYTE[2] als Variable.
Das ist erlaubt solange aus einer Funktion kein Wert zurck gegeben wird.
Geben sie jedoch einen Wert zurck, muss WORD[1] dafr reserviert bleiben.

---------------------------------------------------------------------------
                      BEISPIELE ZUR MICRO
---------------------------------------------------------------------------
Viele Beispiele zur MICRO und IIC-Bus Zubehr laufen auf den PORTS 2 u. 5
Wenn Sie das MICROMODUL als Entwicklungsumgebung verwenden mssen Sie die
Ports auf Port 5 (SDA) und Port 6 (SCL) umdefiniert werden.

Die Beispiele fr die MICRO entstanden, als die Compileroption "MICRO" in 
der BASIC++ IDE noch noch nicht verfgbar war. Sie knnen viele Funktionen 
in den Demos oder auch in der Library vereinfachen, indem sie mit RETURN 
Werte zurck geben. Sie drfen aber dann nicht (wie in den DEMOS geschehen) 
das WORD[1] fr Ihre Zwecke als Variable definieren, da es vom Compiler fr
die Rckgabe von Werten verwendet wird. 

----------------------------------------------------------------------------
                   BEISPIELE ZUR UNIT M 2.0
----------------------------------------------------------------------------
Die meisten Beispiele passen auch zur STATION, wenn dabei kein Zubehr benutzt
wird, das an der STATION prinzipiell nicht anschliessbar ist


