'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIII  BASIC++   DEMO ZUR C-CONTROL UNIT MICRO               IIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER mit dem Application-Board
'--------------------------------------------------------------------
'-----------------------------------------------------------------------
' Beschreibung
' Ein Benchmark zur Messung der Geschwindigkeit der MICRO.
' Die Ausgabe erfolgt uuf ein LCD, angeschlossen an einen PCF 8574
' auf Adresse 01001110b
' Als Zubehr zu MICRO und M 2.0 bekommen Sie ein passendes IIC-BUS
' LC Display unter der Best. Nr 19 83 30
'------------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN

'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
define DATABYTE as byte
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
define INSTRUC100  as byte
define HUNDERTER   as byte
define ZEHNER      as byte
define EINER       as byte
const ADDR=01001110b' LCD ADRESSE


import "...\LIB\ASCII_TABLE.BAS"
import "...\LIB\MICRO_IIC_GENERIC.BAS"
import "...\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "...\LIB\MICRO_IIC_LCD_DRIVE.BAS"
import "...\LIB\MICRO_BMX.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS()
HUNDERTER=INSTRUC100/100
ZEHNER=(INSTRUC100-(HUNDERTER*100))/10
EINER=INSTRUC100-HUNDERTER*100-ZEHNER*10 
END FUNCTION
'----------------------------------------------------

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   MICRO BENCHMARK (IIC-LCD REQUIRED)      II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'----------------------------------------------
pause 2
LCD_INIT(ADDR)
pause 2
'----- WRITE CHARACTERS LINE 1 ---------------
#LOOP
BMX()
SPLIT_DIGITS()
LINE1(ADDR,3)
LCD_WRITE(ADDR,20h,B)
LCD_WRITE(ADDR,20h,M)
LCD_WRITE(ADDR,20h,X)
LCD_WRITE(ADDR,20h,BLANK)
LCD_WRITE(ADDR,20h,HUNDERTER+30h)
LCD_WRITE(ADDR,20h,ZEHNER+30h)
LCD_WRITE(ADDR,20h,EINER+30h)
LCD_WRITE(ADDR,20h,30h)
LCD_WRITE(ADDR,20h,30h)
LCD_WRITE(ADDR,20h,BLANK)
LCD_WRITE(ADDR,20h,I)
LCD_WRITE(ADDR,20h,2Fh)
LCD_WRITE(ADDR,20h,S)

goto LOOP
table tabx
0
END TABLE
attributes
ccproject                   
ccproject                  
              
            
            
           
         
        
       
      
     
    
   
  
 
end attributes
