'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIII  BASIC++   DEMO ZUR C-CONTROL UNIT MICRO               IIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER mit dem Application-Board
'--------------------------------------------------------------------
'-----------------------------------------------------------------------
' Beschreibung
' Ein kleines TOOL um die Codes zu lesen, die Ihre IR-Fernsteuerung sendet.
' Die Ausgabe erfolgt uuf ein LCD, angeschlossen an einen PCF 8574
' auf Adresse &B01001110
'
'---------------------------------------------------------------------------
'
' !!!  DER TREIBER PASST NICHT ZUR MICRO MIT BETRIEBSSYSTEM-VERSION V 2.00 !!!
'
' Ein Tool um die OS-Version festzustellen finden Sie im Verzeichnis MICRO_TOOLS
'----------------------------------------------------------------------------
'-------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'---- IR RECCEIER ---------
define IRIN      port[4]
define COMMAND   byte[1]
define ADDRESS   byte[2]
define DATABYTE as byte
define ZEHNER      as byte
define EINER       as byte
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------

const ADDR=01001110b' LCD ADRESSE


import "....\LIB\ASCII_TABLE.BAS"
import "....\LIB\MICRO_IIC_GENERIC.BAS"
import "....\LIB\MICRO_IIC_PCF8574_IO.BAS"
import "....\LIB\MICRO_IIC_LCD_DRIVE.BAS"

'----------------------------------------------------
'          SPLIT VALUE INTO DIGITS
'----------------------------------------------------
FUNCTION SPLIT_DIGITS()
ZEHNER=DATABYTE/10
EINER=DATABYTE-ZEHNER*10+30h
ZEHNER=ZEHNER+30h 
END FUNCTION

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II   PCF 8574 PORTERWEITERUNG FR LCD        II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'---------- IICBUS INIT ------------------------
SDA=on
SCL=on
'------------   LCD INIT -----------------------
pause 2
LCD_INIT(ADDR)
'--------- IR BACKGROUND RECEIVING INIT --------
SYS FD06h 
ADDRESS=0
COMMAND=0
'------- WRITE CHARACTERS LINE 1 ---------------
LINE1(ADDR,1)
LCD_WRITE(ADDR,20h,W)
LCD_WRITE(ADDR,20h,A)
LCD_WRITE(ADDR,20h,I)
LCD_WRITE(ADDR,20h,T)
LCD_WRITE(ADDR,20h,I)
LCD_WRITE(ADDR,20h,N)
LCD_WRITE(ADDR,20h,G)
LCD_WRITE(ADDR,20h,DOT)
LCD_WRITE(ADDR,20h,DOT)
LCD_WRITE(ADDR,20h,DOT)

#LOOP
if (ADDRESS or COMMAND)=0 then goto LOOP
LINE1(ADDR,1)
LCD_WRITE(ADDR,20h,A)
LCD_WRITE(ADDR,20h,D)
LCD_WRITE(ADDR,20h,R)
LCD_WRITE(ADDR,20h,BLANK)
DATABYTE=ADDRESS
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)

LINE2(ADDR,1)
LCD_WRITE(ADDR,20h,C)
LCD_WRITE(ADDR,20h,M)
LCD_WRITE(ADDR,20h,D)
LCD_WRITE(ADDR,20h,BLANK)
DATABYTE=COMMAND
SPLIT_DIGITS()
LCD_WRITE(ADDR,20h,ZEHNER)
LCD_WRITE(ADDR,20h,EINER)
ADDRESS=0
COMMAND=0
pause 10
LCD_CLR(ADDR)

goto LOOP
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

SYSCODE "RC5_P0.s19"






attributes
ccproject                
ccproject               
           
         
         
        
      
     
    
   
     
 
end attributes
